Index: /pjproject/trunk/build.symbian/bld.inf
===================================================================
--- /pjproject/trunk/build.symbian/bld.inf	(revision 3045)
+++ /pjproject/trunk/build.symbian/bld.inf	(revision 3046)
@@ -1,5 +1,5 @@
 prj_platforms
 winscw
-//armv5
+armv5
 gcce
 
@@ -31,5 +31,4 @@
 
 /* Applications */
-//pjlib_test.mmp
 //symsndtest.mmp
 symbian_ua.mmp
Index: /pjproject/trunk/build.symbian/libg7221codec.mmp
===================================================================
--- /pjproject/trunk/build.symbian/libg7221codec.mmp	(revision 3045)
+++ /pjproject/trunk/build.symbian/libg7221codec.mmp	(revision 3046)
@@ -4,4 +4,5 @@
 //OPTION		CW -lang c++
 OPTION		GCCE -O2 -fno-unit-at-a-time
+OPTION          ARMCC --gnu
 
 MACRO		PJ_M_I386=1
Index: /pjproject/trunk/build.symbian/libgsmcodec.mmp
===================================================================
--- /pjproject/trunk/build.symbian/libgsmcodec.mmp	(revision 3045)
+++ /pjproject/trunk/build.symbian/libgsmcodec.mmp	(revision 3046)
@@ -20,4 +20,5 @@
 
 //OPTION		CW -lang c++
+OPTION          ARMCC --gnu
 
 MACRO		PJ_M_I386=1
Index: /pjproject/trunk/build.symbian/libpassthroughcodec.mmp
===================================================================
--- /pjproject/trunk/build.symbian/libpassthroughcodec.mmp	(revision 3045)
+++ /pjproject/trunk/build.symbian/libpassthroughcodec.mmp	(revision 3046)
@@ -10,4 +10,5 @@
 //
 OPTION		GCCE -O2 -fno-unit-at-a-time
+OPTION          ARMCC --gnu
 
 //
Index: /pjproject/trunk/build.symbian/libresample.mmp
===================================================================
--- /pjproject/trunk/build.symbian/libresample.mmp	(revision 3045)
+++ /pjproject/trunk/build.symbian/libresample.mmp	(revision 3046)
@@ -8,4 +8,5 @@
 //
 OPTION		GCCE -O2 -fno-unit-at-a-time
+OPTION          ARMCC --gnu
 
 MACRO		PJ_M_I386=1
Index: /pjproject/trunk/build.symbian/libspeexcodec.mmp
===================================================================
--- /pjproject/trunk/build.symbian/libspeexcodec.mmp	(revision 3045)
+++ /pjproject/trunk/build.symbian/libspeexcodec.mmp	(revision 3046)
@@ -10,4 +10,5 @@
 //
 OPTION		GCCE -O2 -fno-unit-at-a-time
+OPTION          ARMCC --gnu
 
 //
Index: /pjproject/trunk/build.symbian/libsrtp.mmp
===================================================================
--- /pjproject/trunk/build.symbian/libsrtp.mmp	(revision 3045)
+++ /pjproject/trunk/build.symbian/libsrtp.mmp	(revision 3046)
@@ -9,4 +9,5 @@
 //
 OPTION		GCCE -O2 -fno-unit-at-a-time
+OPTION          ARMCC --gnu
 
 //
Index: /pjproject/trunk/build.symbian/null_audio.mmp
===================================================================
--- /pjproject/trunk/build.symbian/null_audio.mmp	(revision 3045)
+++ /pjproject/trunk/build.symbian/null_audio.mmp	(revision 3046)
@@ -23,4 +23,5 @@
 
 OPTION		CW -lang c++
+OPTION          ARMCC --gnu
 
 MACRO		PJ_M_I386=1
Index: /pjproject/trunk/build.symbian/pjlib.mmp
===================================================================
--- /pjproject/trunk/build.symbian/pjlib.mmp	(revision 3045)
+++ /pjproject/trunk/build.symbian/pjlib.mmp	(revision 3046)
@@ -25,5 +25,5 @@
 // Must compile as C++, otherwise exception would not work
 OPTION          CW -lang c++
-OPTION          ARMCC --cpp
+OPTION          ARMCC --cpp --gnu
 OPTION          GCC     -x c++
 OPTION          GCCE    -x c++
Index: /pjproject/trunk/build.symbian/pjlib_test.mmp
===================================================================
--- /pjproject/trunk/build.symbian/pjlib_test.mmp	(revision 3045)
+++ /pjproject/trunk/build.symbian/pjlib_test.mmp	(revision 3046)
@@ -11,5 +11,5 @@
 // Must compile as C++, otherwise exception would not work
 OPTION CW -lang c++
-OPTION ARMCC --cpp
+OPTION ARMCC --cpp --gnu
 OPTION GCC -x c++
 OPTION GCCE -x c++
Index: /pjproject/trunk/build.symbian/pjlib_util.mmp
===================================================================
--- /pjproject/trunk/build.symbian/pjlib_util.mmp	(revision 3045)
+++ /pjproject/trunk/build.symbian/pjlib_util.mmp	(revision 3046)
@@ -25,5 +25,5 @@
 // Must compile as C++, otherwise exception would not work
 OPTION          CW -lang c++
-OPTION          ARMCC --cpp
+OPTION          ARMCC --cpp --gnu
 OPTION          GCC -x c++
 OPTION          GCCE -x c++
Index: /pjproject/trunk/build.symbian/pjmedia.mmp
===================================================================
--- /pjproject/trunk/build.symbian/pjmedia.mmp	(revision 3045)
+++ /pjproject/trunk/build.symbian/pjmedia.mmp	(revision 3046)
@@ -31,5 +31,5 @@
 // Must compile as C++, otherwise exception would not work
 OPTION          CW -lang c++
-OPTION          ARMCC --cpp
+OPTION          ARMCC --cpp --gnu
 OPTION          GCC     -x c++
 OPTION          GCCE    -x c++
Index: /pjproject/trunk/build.symbian/pjmedia_audiodev.mmp
===================================================================
--- /pjproject/trunk/build.symbian/pjmedia_audiodev.mmp	(revision 3045)
+++ /pjproject/trunk/build.symbian/pjmedia_audiodev.mmp	(revision 3046)
@@ -8,4 +8,5 @@
 //
 //OPTION		GCCE -O2 -fno-unit-at-a-time
+OPTION          ARMCC --gnu
 
 MACRO		PJ_M_I386=1
Index: /pjproject/trunk/build.symbian/pjnath.mmp
===================================================================
--- /pjproject/trunk/build.symbian/pjnath.mmp	(revision 3045)
+++ /pjproject/trunk/build.symbian/pjnath.mmp	(revision 3046)
@@ -17,4 +17,6 @@
 
 #endif
+
+OPTION          ARMCC --gnu
 
 SOURCEPATH	..\pjnath\src\pjnath
Index: /pjproject/trunk/build.symbian/pjsdp.mmp
===================================================================
--- /pjproject/trunk/build.symbian/pjsdp.mmp	(revision 3045)
+++ /pjproject/trunk/build.symbian/pjsdp.mmp	(revision 3046)
@@ -25,5 +25,5 @@
 // Must compile as C++, otherwise exception would not work
 OPTION          CW -lang c++
-OPTION          ARMCC --cpp
+OPTION          ARMCC --cpp --gnu
 OPTION          GCC     -x c++
 OPTION          GCCE    -x c++
Index: /pjproject/trunk/build.symbian/pjsip.mmp
===================================================================
--- /pjproject/trunk/build.symbian/pjsip.mmp	(revision 3045)
+++ /pjproject/trunk/build.symbian/pjsip.mmp	(revision 3046)
@@ -28,5 +28,5 @@
 // Must compile as C++, otherwise exception would not work
 OPTION          CW -lang c++
-OPTION          ARMCC --cpp
+OPTION          ARMCC --cpp --gnu
 OPTION          GCC     -x c++
 OPTION          GCCE    -x c++
Index: /pjproject/trunk/build.symbian/pjsip_simple.mmp
===================================================================
--- /pjproject/trunk/build.symbian/pjsip_simple.mmp	(revision 3045)
+++ /pjproject/trunk/build.symbian/pjsip_simple.mmp	(revision 3046)
@@ -28,5 +28,5 @@
 // Must compile as C++, otherwise exception would not work
 OPTION          CW -lang c++
-OPTION          ARMCC --cpp
+OPTION          ARMCC --cpp --gnu
 OPTION          GCC     -x c++
 OPTION          GCCE    -x c++
Index: /pjproject/trunk/build.symbian/pjsip_ua.mmp
===================================================================
--- /pjproject/trunk/build.symbian/pjsip_ua.mmp	(revision 3045)
+++ /pjproject/trunk/build.symbian/pjsip_ua.mmp	(revision 3046)
@@ -28,5 +28,5 @@
 // Must compile as C++, otherwise exception would not work
 OPTION          CW -lang c++
-OPTION          ARMCC --cpp
+OPTION          ARMCC --cpp --gnu
 OPTION          GCC     -x c++
 OPTION          GCCE    -x c++
Index: /pjproject/trunk/build.symbian/pjstun_client.mmp
===================================================================
--- /pjproject/trunk/build.symbian/pjstun_client.mmp	(revision 3045)
+++ /pjproject/trunk/build.symbian/pjstun_client.mmp	(revision 3046)
@@ -2,4 +2,6 @@
 TARGETTYPE 	exe
 UID		0x0 0xA000000A
+
+OPTION          ARMCC --gnu
 
 SOURCEPATH	..\pjnath\src\pjstun-client
Index: /pjproject/trunk/build.symbian/pjsua_lib.mmp
===================================================================
--- /pjproject/trunk/build.symbian/pjsua_lib.mmp	(revision 3045)
+++ /pjproject/trunk/build.symbian/pjsua_lib.mmp	(revision 3046)
@@ -28,5 +28,5 @@
 // Must compile as C++, otherwise exception would not work
 OPTION          CW -lang c++
-OPTION          ARMCC --cpp
+OPTION          ARMCC --cpp --gnu
 OPTION          GCC     -x c++
 OPTION          GCCE    -x c++
Index: /pjproject/trunk/build.symbian/symbian_audio.mmp
===================================================================
--- /pjproject/trunk/build.symbian/symbian_audio.mmp	(revision 3045)
+++ /pjproject/trunk/build.symbian/symbian_audio.mmp	(revision 3046)
@@ -26,4 +26,5 @@
 OPTION		CW -lang c++
 OPTION		GCCE -O2 -fno-unit-at-a-time
+OPTION          ARMCC --gnu
 
 MACRO		PJ_M_I386=1
Index: /pjproject/trunk/build.symbian/symbian_ua.mmp
===================================================================
--- /pjproject/trunk/build.symbian/symbian_ua.mmp	(revision 3045)
+++ /pjproject/trunk/build.symbian/symbian_ua.mmp	(revision 3046)
@@ -9,4 +9,6 @@
 
 SOURCEPATH		..\pjsip-apps\src\symbian_ua
+
+OPTION			ARMCC --gnu
 
 MACRO			PJ_M_I386=1
Index: /pjproject/trunk/build.symbian/symsndtest.mmp
===================================================================
--- /pjproject/trunk/build.symbian/symsndtest.mmp	(revision 3045)
+++ /pjproject/trunk/build.symbian/symsndtest.mmp	(revision 3046)
@@ -5,4 +5,6 @@
 TARGETTYPE 		exe
 UID			0x0 0xA000000E
+
+OPTION			ARMCC --gnu
 
 SOURCEPATH		..\pjsip-apps\src\symsndtest
Index: /pjproject/trunk/pjlib/include/pj/compat/cc_armcc.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/compat/cc_armcc.h	(revision 3045)
+++ /pjproject/trunk/pjlib/include/pj/compat/cc_armcc.h	(revision 3046)
@@ -31,7 +31,7 @@
 
 #define PJ_CC_NAME		"armcc"
-#define PJ_CC_VER_1		__ARMCC__
-#define PJ_CC_VER_2		__ARMCC_MINOR__
-#define PJ_CC_VER_3		__ARMCC_PATCHLEVEL__
+#define PJ_CC_VER_1             (__ARMCC_VERSION/100000)
+#define PJ_CC_VER_2             ((__ARMCC_VERSION%100000)/10000)
+#define PJ_CC_VER_3             (__ARMCC_VERSION%10000)
 
 #ifdef __cplusplus